<?php
 /****************************************************************************************************************
  ** class DateSel
  **
  ** Author:  Simon Taylor
  ** Date:    28th November 2002
  ** email:   simon.taylor@afritol.co.za
  ** License: feel free to distribute this software, as long as the header remains in tact.
  ****************************************************************************************************************
  ** Usage...
  **
  ** This is my date selector class - just include this file in the top of your code
  ** and where you want to insert a date selector you insert the following lines of code..
  **
  ** first insert the style bit, you can put this in a separate file if you like
  **
  ** <style>
  **   .actionbuttonssmall{background-color: Green;border: 0px;color: Aqua;width: 25px;height: 20px;font-size: 9px;}
  **   .actionbuttonsbig{background-color: Green;border: 0px;color: Aqua;width: 45px;height: 20px;font-size: 9px;}
  **   .yearokbutton{background-color: Gray;border: 0px;color: Aqua;width: 15px;height: 20px;font-size: 9px;}
  **   .daybuttons{border: 0px;width: 25px;height: 15px;background-color: #EEEEEE ;background: #EEEEEE ;font-family: Tahoma;font-size: 12px;position: relative;}
  **   .presseddaybutton{border: 2px;width: 25px;height: 15px;background: white ;font-family: Tahoma;font-size: 12px;position: relative;}
  **   .caltable {border: 0px;background-color: #EEEEEE;font-family: Tahoma;font-size: 12px;}
  **   .monthyear {border: 0px;background-color: Silver;font-family: Tahoma;font-size: 12px;align :center}
  ** </style>
  **
  ** now you need a control to use as the target of the selectors value..in a form
  ** 				<form>
  **   				<input type="text" name="tst">
  ** 				</form>
  **
  ** now insert your lines of php as follows.
  ** 			
  ** 				require('./includes/datesel.inc');
  ** 				$dsel = new DateSel("document.forms[0].tst.value",true,'mo','yyyy-mm-dd');
  ** 				print $dsel->ChangeButton('both');
  ** 				print $dsel->DrawCal();
  ** 				print $dsel->AddJavascript();
  ** 				print $dsel->setDate('y2003m05d18');
  **	
  ** 	Above in the line $dsel = new DateSel("document.forms[0].tst.value",true,'mo','yyyy-mm-dd');
  **	[required] string  - the first value you are passing to the constructor is the target for the date selection ,
  **  [optional] boolean - the second is whether or not to create it's own form,
  **  [optional] string  - the third controls which day of the week appears first,
  **  [optional] string  - the last value is the format the date must be displyed in, it cacn be anything, bust must contain, yyyy, mm and dd ie. yyyy-mm-dd
  **
  **  If you want the date selector to be inside your form all you need do is the following..
  **
  **  print "<form>
  **           <input type=text name=tst>";
  **
  **  require('./includes/datesel.inc');
  **  $dsel = new DateSel("document.forms[0].tst.value");
  **  print $dsel->ChangeButton('both');
  **  print $dsel->DrawCal();
  **  print $dsel->AddJavascript();
  **  print $dsel->setDate('y2010m05d18');
  **
  **  print "</form>";
  **
  **
  ****************************************************************************************************************
  ** NOTE:: there is a new feature to be able to type in the date manually, this will only accept 4 digit date,
  **        it will produce unxepected results otherwise.
  ****************************************************************************************************************
  **
  ** Explanation of Parameters for all the functions..
  **
  **
  ** $dsel = new DateSel($outputstr,$inform);
  ** The constructor takes two arguments,
  **  1. $outputstr - required - string - This is the target for the date selection, usually a text input
  **                                       box such as "document.forms[0].tst.value".
  **  2. $inform - optional default(false) - boolean - Should the class create it's own form tags, if set
  **                                    to true it will, the default is false in which case you must make
  **                                      sure you create them before and after calling the class.
  **  3. $firstday - optional default 'su' - string - this must be a two digit lower case day representation for the day
  **                                    of the week you would like the calendar to start on.
  **  4. $dateformat - optional default 'yyyy-mm-dd' - string - this is an optional facility, the string you put in must have
  **                                      the three value in yyyy, mm and dd to function and they must be in lower case.
  **
  **
  ** $dsel->ChangeButton($what)
  ** This function gives us a button with which we can make the date selector appear
  ** 1. $what - optional default('both') - string - This is what should be returned, can be one of the following:
  **                        'anchor' = this will return the anchor which the calendar will be centered on
  **                                    if the Change Button is pushed
  **                        'button' = this will return the button to make the calendar apppear
  **                        'both' = this will return both of the above.
  ** This means you can call this function in one part of your page with the button argument
  ** then you can call it in another part of the page with the anchor argument to make it appear there if pushed.
  ** Not this is an optional function as long as you pay attention to the following one's paremters
  **
  ** $dsel->DrawCal($indiv,$visible);
  ** This is the function that draws the calendar for us, it takes two optional arguments
  ** 1. $indiv - optional default(true) - boolean - Should the DateSelector be drawn in a div or not
  **                                               (used to make it appear and disappear)
  ** 2. $visible - optional default('hidden') - string - This is the visibility of the div mentioned above.
  **
  ** $dsel->AddJavascript();
  ** This is just used to add the javascript part to your page, it is a separate function so you can put it
  ** anywhere you like..
  **
  ** $dsel->setDate($str);
  ** This sets the date on the date selector and if you just look at what it does you can use the same piece of
  ** Javascript to set the date dynamically on your page if you want to ..
  ** It takes the following parameter
  ** 1. $str - optional default('now') - string - use 'now' to set it to today, otherwise the format is y2002m01d03
  **
  ****************************************************************************************************************
  **  Version 1.2 - 7th January 2003
  **  Changes in version 1.2 - thanks for all the emails adn a happy new year..
  **
  **  Bugs Fixed
  **  - Not really a bug, but the selector would generate about 40k of html and javascript when it ran, I have managed to
  **    get this down to about 16K.
  **
  **  Design Changes
  **  - The selector now makes use of a stylesheet which allows you to modify most of the parameters, if there is something
  **    I have left out just drop me an email..
  **  - As explained in the usage section there are two more optional features.
  **     1. You can specify which day of the week must come first ie. 'mo', 'tu' etc..
  **     2. You can specify the format in which the date comes out the other end. ie 'mm-dd-yyyy' (for you strange yanks..)
  **
  ****************************************************************************************************************
  **  Version 1.1
  **  Changes in version 1.1 - thanks to input from users on phpclasses.org
  **
  **  Bugs Fixed
  **  - fixed Year to use getFullYear instead of FullYear, now the date selector works with all years
  **           - thanks Michelle Byrd for noticing
  **
  **  Design Changes
  **  - Now when you click on today or you click on a date, the date selector closes itself automatically.
  **  - Finally stripped out the debugging information contained in the code..
  **  - Made the ctype function optional (it being something I use a lot I never thought of people having
  **              to change their php install)
  **  - Added in an option to let the date selector create it's own form or not..
  **              ( if set to true on the constructor the class will create it's own pair of <form></form> tags..
  **                 note that if these are created inside another form it will not function..
  **                 default behaviour is set to false.)
  **  - Added the ability to type in the year you want to jump to, this will only accept a 4 digit year.
  **
  ****************************************************************************************************************
  **
  **/

class DateSel {
	
   /** Background colour for the date selector
    ** @type string
    **/
	var $bgcolor;

   /** Style for the next and prev buttons..
    ** @type string
    **/
	var	$btnstyle;

   /** the editbox which you are using for the dates themselves
    ** @type string
    **/
	var $edbox;

   /** this is the id of the form for the date selector.. between 50 and 1000
    ** @type string
    **/
	var $formid;

   /** this is the output str which we need to use for this form
    ** @type string
    **/
	var $outputstr;

   /** this is the vlaue of the output that the class will generate
    ** @type string
    **/
	var $output;

   /** Should the class create it's own form tags..
    ** @type boolean
    **/
	var $inform;

   /** which must be the first day of the week..
    ** @type string
    **/
	var $firstday;

   /** what must the date format be.
    ** @type string
    **/
	var $dateformat;

	/**
    ** DateSel::DateSel()
    **
    ** This is the class's constructor, it just sets up some variables.
    **
    ** @param  outputstr string - this is the string where the date must be filled in.. such as.. document.all.test.value
    ** @param  inform    boolean- Should the date selector create it's own form, if so set this to true, else you must create one for it..
    ** @param  firstday  string - This is the first day of the week, defaults to sun - must be 2 letter....'mo', 'tu', 'we' etc..
    ** @param  dateformat string- This is the format of the date as it should come out, anything as long as yy or yyyy, mm, dd are in the string they will be replaced..
    **                              ie..  mm, -yyyy:dd     will still work fine..
    **/
 	function DateSel ($outputstr, $inform=false, $firstday = 'su', $dateformat= 'yyyy-mm-dd')
	{
		// set the properties
		$this->inform = $inform;
		$this->bgcolor = '#EEEEEE';
		$this->btnstyle = " class=actionbuttonssmall ";
		$this->ok_btnstyle = " class=yearokbutton ";
		$this->formid = '_ds'.rand(50,1000);
		$this->edbox = "<input type=button name='s' onClick=animate".$this->formid."(this,'button') readonly class=daybuttons ";
		$this->outputstr = $outputstr;
		$this->output = '';
      $this->firstday = $firstday;
      $this->dateformat = $dateformat;
   }
	
	/**
    ** DateSel::AddJavascript()
    **
    ** add in the javascript to the file.
    **
    **
    **/
	function AddJavascript()
	{
	
		//enable this for logging.
		//$this->dsLogsetup();
	
		$output = "
		<script type='text/javascript'>

		var prevBox".$this->formid.";
			
			// this is to make the div appear at the change button's anchor
			function divAppear".$this->formid."()
			{
				div".$this->formid.".style.pixelTop = anchor".$this->formid.".offsetTop
				div".$this->formid.".style.pixelLeft = anchor".$this->formid.".offsetLeft
				div".$this->formid.".style.visibility = 'visible'
			}

         // This makes the div disappear
			function divdisAppear".$this->formid."()
			{
				div".$this->formid.".style.visibility = 'hidden'
			}
			
			// this function sorts out the date depending on if it is new - currentdate or if prev or next on the form have
			// been pressed then it gives us the next or previous months to tabulate
			//
         // @param   dir   string This is the direction which the date must go in.. either 'prev' or 'next' or 'now' (for today's date)
			// @param   from  string Ths is where this is being called from, either 'original' or
         //
         function sortDate".$this->formid."(dir,from)
			{
				
            // if there is a previous date we must get it's value and return a new current date based on the advance of the selection
				if ((dir != 'now')&&(document.all.hid_year".$this->formid.".value != ''))
				{
					var prevYear".$this->formid." = document.all.hid_year".$this->formid.".value
					var prevMonth".$this->formid." = document.all.hid_month".$this->formid.".value
					if (dir == 'prev')
					{
						if (prevMonth".$this->formid." == 0)
						{
							prevMonth".$this->formid." = 11;
							prevYear".$this->formid." = Number(prevYear".$this->formid.") - 1;
						}else{
							prevMonth".$this->formid." = Number(prevMonth".$this->formid.") - 1;
						}
					}
					else if (dir == 'next')
					{
						if (prevMonth".$this->formid." == 11)
						{
							prevMonth".$this->formid." = 0;
							prevYear".$this->formid." = Number(prevYear".$this->formid.") + 1;
						}else{
							prevMonth".$this->formid." = Number(prevMonth".$this->formid.") + 1;
						}
					}
					currentDate".$this->formid." = new Date(prevYear".$this->formid.",prevMonth".$this->formid.",1,00,00,00,001);
				}
				
				// if the dir has been set to now then we must just set the date to present day.
				if (dir == 'now')
				{
					currentDate".$this->formid." = new Date();
					document.all.hid_dayom".$this->formid.".value = currentDate".$this->formid.".getDate();
				
            // OR is the dir has been set to a ymd value then set it to then..	
				}else if (dir.substr(0,1) == 'y'){
				   // set the current date to y(year)m(month)d(day),00,00,00,001
               // if we have just been passed the year then produce the rest of the string.
				   if (dir.length == 5){
				      dir = dir + 'm'
                  if (document.all.hid_month".$this->formid.".value < 9){
                     dir = dir + '0'
                  }
                  temp_month = Number(document.all.hid_month".$this->formid.".value) + 1
                  dir = dir + temp_month
				      dir = dir + 'd'

                  if (document.all.hid_dayom".$this->formid.".value < 10){
                     dir = dir + '0'
                  }
                  dir = dir + document.all.hid_dayom".$this->formid.".value
               }
					currentDate".$this->formid." = new Date(dir.substr(1,4),dir.substr(6,2) -1,dir.substr(9,2),00,00,00,001);
					document.all.hid_dayom".$this->formid.".value = currentDate".$this->formid.".getDate();
				}
				year".$this->formid." = currentDate".$this->formid.".getFullYear();
				month".$this->formid." = currentDate".$this->formid.".getMonth();
				newdate".$this->formid." = new Date(year".$this->formid.",month".$this->formid.",1,00,00,00,001);
				";

            // this is the first day of the month, Getday gives you 0 for sunday and so on..
            // Lets get the key number of the chosen day of the week which we have
            $daysofweek = Array('su','mo','tu','we','th','fr','sa');
            $key = array_search($this->firstday,$daysofweek);	

            $output .= "

            firstday".$this->formid." = newdate".$this->formid.".getDay() - ".$key.";
				if (firstday".$this->formid." == -1)
				  firstday".$this->formid." = 6;

            days".$this->formid." = NumDays".$this->formid."(month".$this->formid.",year".$this->formid.");
				
            // now set the values got above into the hidden form elements..
            document.all.hid_year".$this->formid.".value = year".$this->formid."
				document.all.hid_month".$this->formid.".value = month".$this->formid."
				document.all.hid_day".$this->formid.".value = currentDate".$this->formid.".getDay();
				mo".$this->formid." = transmonth".$this->formid."(month".$this->formid.")
				document.all.cal_fullmonth".$this->formid.".value = mo".$this->formid."
				document.all.cal_fullyear".$this->formid.".value = year".$this->formid."
				FillCal".$this->formid."(from);
				
			}
			
			// this function returns the number of days in the given month..
			function NumDays".$this->formid."(month".$this->formid.",year".$this->formid.")
			{
			if ( (month".$this->formid." == 3) || (month".$this->formid." == 5) || (month".$this->formid." == 8) || (month".$this->formid." == 10) ) {
				    days".$this->formid." = 30;
				  }
				  else if (month".$this->formid." == 1) {
				    // check for leapyear - Any year divisible by 4, except those divisible by 100 (but NOT 400)
				    if ((Math.floor(year".$this->formid."/4) == (year".$this->formid."/4)) && ((Math.floor(year".$this->formid."/100) != (Math.year".$this->formid."/100)) || (Math.floor(year".$this->formid."/400) == (year".$this->formid."/400))) )
				      days".$this->formid." = 29;
				    else
				      days".$this->formid." = 28;
				  }
				  else {
				    days".$this->formid." = 31;
				  }
			return days".$this->formid.";
			}
			
			// this is the function that animates your selection on the grid..
			// from is either original or button - telling it whether to update the outputbox or not..
			//
			// @param   Sender   object   This is the object which is calling this function.. (ie. the button pressed)
			// @param   from     string   This is a from value in case it is not from the button..
         //
			function animate".$this->formid."(Sender,from)
			{
				sText".$this->formid." = Sender.value
				if (sText".$this->formid." != '')
				{
					// this is to reset the previously selected button once a new one is pressed
               if (prevBox".$this->formid.") {
                  prevBox".$this->formid.".className = 'daybuttons';
					   prevBox".$this->formid.".style.background = '".$this->bgcolor."';
		          }
					// set up a new previous button so we can use this value next time we press a button
               prevBox".$this->formid." = Sender;
					
               // Change the style of the currently pressed button.
               Sender.className = 'presseddaybutton';
					Sender.style.background = 'white';
					
					// Set the month value
               month".$this->formid." = Number(month".$this->formid.");
					
               // if it is from a button then set the actual value in the outputstr which is the form element we wish to fill..
               if (from == 'button'){
                  // lets now put together a string to send to the output..
                  re = /yyyy/i;
                  str = '".$this->dateformat."';
                  str=str.replace(re, year".$this->formid.");
                  re = /mm/i;
                  str=str.replace(re, String(Number(month".$this->formid.")+1));
                  re = /dd/i;
                  str=str.replace(re, sText".$this->formid.");


                  ".$this->outputstr." = str;
                  divdisAppear".$this->formid."()
               }
            }
			}
			
			// this is the function which does the job of filling the calendar
			
         function FillCal".$this->formid."(from)
			{
				var val".$this->formid." = 1
				var day".$this->formid." = document.all.hid_day".$this->formid.".value
				dayom".$this->formid." = document.all.hid_dayom".$this->formid.".value;
				currid".$this->formid." = '';
				
			
			   // here we set the values and style of the buttons marking the days.
			   
				for (var i = 0 ; i < 38 ; i++){
					// below function explained -
					
               //			if ((day(day of week) = i + day -1) and (val(incrementing value) < days(in month)) OR ((val > 1) and (val < days(in month))
					//				then output the value to the textbox, otherwise reset it..
					
					
					if (((firstday".$this->formid." == i)&&(val".$this->formid." <= days".$this->formid."))||((val".$this->formid." > 1)&&(val".$this->formid." <= days".$this->formid.") ) )
					{
						document.getElementById('id".$this->formid."' + i).value = val".$this->formid.";
						document.getElementById('id".$this->formid."' + i).style.background = '".$this->bgcolor."'
						if ((dayom".$this->formid." == val".$this->formid.")&&(dayom".$this->formid." != '')) currid".$this->formid." = document.getElementById('id".$this->formid."' + i);
						val".$this->formid."++;
					} else {
						document.getElementById('id".$this->formid."' + i).value = '';
						document.getElementById('id".$this->formid."' + i).style.background = '".$this->bgcolor."'
						
					}
				}
			
   			if (currid".$this->formid.") animate".$this->formid."(currid".$this->formid.",from);
			}
			
	


   		function transmonth".$this->formid."(month".$this->formid.")
			{
				
				switch (month".$this->formid.") {
					case 0:
						mo".$this->formid." = 'January'
					break;
					case 1:
						mo".$this->formid." = 'February'
					break;
					case 2:
						mo".$this->formid." = 'March'
					break;
					case 3:
						mo".$this->formid." = 'April'
					break;
					case 4:
						mo".$this->formid." = 'May'
					break;
					case 5:
						mo".$this->formid." = 'June'
					break;
					case 6:
						mo".$this->formid." = 'July'
					break;
					case 7:
						mo".$this->formid." = 'August'
					break;
					case 8:
						mo".$this->formid." = 'September'
					break;
					case 9:
						mo".$this->formid." = 'October'
					break;
					case 10:
						mo".$this->formid." = 'November'
					break;
					case 11:
						mo".$this->formid." = 'December'
					break;
				}
				return mo".$this->formid.";	
			}
			
		</script>
		";
		return $output;
	}

	/**
    ** DateSel::DrawCal()
    **
    ** this function draws the actual calender and takes the following parameters
    **
	 ** @ param - indiv - string - Yes or No - draw the calendar in a div or not..(optional) (default - Yes)
	 ** @ param - visible - string - hidden or visible - if the above is true - is the div visible (optional)(default - hidden)
    **/
	function DrawCal($indiv=true,$visible='hidden')
	{
		$output = '';
		if ($indiv) $output .=  "<div id=div".$this->formid." style='position:absolute; visibility:".$visible."'>";
      if ($this->inform) $output .= "<form id=".$this->formid." name=".$this->formid.">";
		
      $output .= "<input type=hidden name=hid_year".$this->formid.">
			<input type=hidden name=hid_month".$this->formid.">
			<input type=hidden name=hid_day".$this->formid.">
			<input type=hidden name=hid_dayom".$this->formid.">
			<table border=0 cellspacing=0 cellpadding=0 style='border: 0px;'>
				<tr>
					<td></td>
					<td bgcolor='#000000'><img height=1 src='./images/pixT.gif'></td>
					<td></td>
				</tr>
				<tr>
					<td bgcolor='#000000'><img src='./images/pixT.gif' width=1></td>
					<td bgcolor=".$this->bgcolor.">
						<table border=0 cellspacing=0 cellpadding=0 style='border: 0px;'>
							<tr>
								<td>
								<table border=0 cellspacing=0 cellpadding=0 class=caltable>
									<tr cellspacing=0 cellpadding=0 bgcolor=Gray>
										<td><input ".$this->btnstyle." type=button value=prev onClick=sortDate".$this->formid."('prev','original')></td>
										<td align=center colspan=3><input align=center type=text name=cal_fullmonth".$this->formid."
                                    readonly size=12 class=monthyear></td>
										<td align=center colspan=1><input align=center type=text name=cal_fullyear".$this->formid."
                                    size=2 value='' class=monthyear></td>
                              <td><input ".$this->ok_btnstyle." type=button value=ok
                                       onClick=".'"'."sortDate".$this->formid."('y' + cal_fullyear".$this->formid.".value)".'"'."></td>
										<td><input ".$this->btnstyle." type=button value=next onClick=sortDate".$this->formid."('next','original')></td>
									</tr>
									<tr>";
							
                     // here is the code to get the first day of the week right..
                     $daysofweek = Array('mo','tu','we','th','fr','sa','su');
                     $key = array_search($this->firstday,$daysofweek);	

                     for ($i = 0; $i < 7; $i++ ){
                        $output .= "<td align=center>".$daysofweek[$key]."</td>";
                        $key++;
                        if ($key == 7) $key = 0;
                     }

									$output .= "</tr>
								";
								$id = 0;
								for ($l = 0;$l < 6;$l++){
									$output .= "<tr>";
									for ($c = 0;$c < 7;$c++){
										if ($id < 38){
											$output .=  "<td>".$this->edbox." id=id".$this->formid.$id."></td>";
											$id++;
										}else{
											if ($id == 38){
												$output .= "<td align=right colspan=2><input class=actionbuttonssmall type=button value=OK onClick=divdisAppear".$this->formid."()></td>";
												$id++;
											}else{
												$output .= "<td align=right colspan=2><input class=actionbuttonsbig type=button value=Today onClick=sortDate".$this->formid."('now','button')></td>";
												$c = $c + 2;
											}
										}
									}
									$output .=  "</tr>";
								}
								$output .= "
								</table></td>
										</tr>
									</table>
								</td>
								<td bgcolor='#000000'><img src='./images/pixT.gif' width=1></td>
							</tr>
							<tr>
								<td></td>
								<td bgcolor='#000000'><img height=1 src='./images/pixT.gif'></td>
								<td></td>
							</tr>
						</table>";
						//enable this for logging..
						//$output .= "<textarea rows=100 cols=100 id=log></textarea>";
					if ($this->inform) $output .= "</form>";
		if ($indiv) $output .=  "</div>";
		return $output;
	}
	
	
	/**
    ** DateSel::setDate()
    **
    ** this function is used to set the date - use 'now' to set it to today, otherwise the format is y2002m01d03
    **
    **/
	function setDate($str='now')
	{
		if (function_exists('ctype_digit'))
         if (!ctype_digit(substr($str,1,4))) $str = 'now';
		
      $output = "<script type='text/javascript'>
				sortDate".$this->formid."('".$str."')
			</script>";
		return $output;
	}
	
	/**
    ** DateSel::ChangeButton()
    **
    ** this function puts a Change button on the screen which basically will make the date selector appear so you can change the date..
    **
    ** @param $what - string - This is what should be returned, can be one of the following:
    **                        'anchor' = this will return the anchor which the calendar will be centered on
    **                                    if the Change Button is pushed
    **                        'button' = this will return the button to make the calendar apppear
    **                        'both' = this will return both of the above.
    **/
	function ChangeButton($what='both')
	{
		$style = " style='background-color: Silver; height:0;width:0; border:0px' width=0 height=0 border=0 cellspacing=0 cellpadding=0 ";
		if ($what == 'anchor')$output = "<table ".$style."><tr".$style."><td id=anchor".$this->formid." style='position:relative;'".$style."></td></tr></table>";
		if ($what == 'button')$output = "<input class=actionbuttonsbig	type=button value=Change onClick=divAppear".$this->formid."()>";
		if ($what == 'both') $output = "<table ".$style."><tr".$style."><td ".$style."id=anchor".$this->formid." style='position:relative;'></td></tr></table>
				<input class=actionbuttonsbig	type=button value=Change onClick=divAppear".$this->formid."()>";
		return $output;
	}
}

?>
